#ifndef DDB_HPP
#define DDB_HPP

struct mem_area_t
{
	void *start;
	void *end;
};

struct const_mem_area_t
{
	void const* start;
	void const* end;
};

// adds records into buffer, if possible.
//
// buffer: where to write records
// key_list: where to read and add keys
// input: where to read new records
// returns a pointer on 1st unused byte
void* record( const_mem_area_t input, mem_area_t buffer, vector<string>& key_list );

enum step_t
{
	KEY,
	VALUE,
	LONG_VALUE,
};

bool invalidate_key( const_mem_area_t key )
{
	// key string should contain the terminal ": " string
	if( key.end - key.start < 3 || strcmp( key.end - 2, ": ", 2 ) )
	{
		return true;
	}
	// should only contain graphical characters
	for( ; key->start != key->end; ++key->start )
	{
		const char ch = *key->start;
		if( !isgraph( ch ) )
		{
			return true;
		}
	}
	return false;
}

void* record( const_mem_area_t input, mem_area_t buffer, vector<string>& key_list )
{
	char const* ptr = input.start;
	step_t step = KEY;
	const_mem_area_t key = { ptr, ptr };
	const_mem_area_t val;

	while( ptr != input.end )
	{
		while( ptr != input.end && step == KEY )
		{
			if( *ptr == ' ' )
			{
				key.end = ptr + 1;
				assert( invalidate_key( key ) );
				if( invalidate_key( key ) )
				{
					//TODO
				}
				step = VALUE;
				val.start = ptr + 1;
			}
			++ptr;
		}
		while( ptr != input.end && step == VALUE )
		{
			if( *ptr == '\n' )
			{
				val.end = ptr + 1;
				// empty value
				if( val.end - val.start < 2 )
			}
		}
	}
}

#endif
