// FRontend for shELl
// this program's intent is to make a layer over any any POSIX shells
// so that the use of even non-interactive shells would be less tedious
// than the use of powerful interactive shells (like zsh of fish) but
// with less resource overhead, and easier configuration.
// Planned features are:
// * keep stdout and stderr of commands split
// * keep stdout and stderr outputs of a specific command (up to some
//   command age or frel's memory usage)
// * line timestamps on stderr and stdout buffers
// * ability to send a buffer's part into either a 3rd party command
//   or on current command-line
// * basic but obvious aliases of built-in commands like `cd` so that
//   it can go up multiple levels faster (`cd ...` for example) and
//   automatically displays the new folder's content (`cd $target; ls`)
// * basic file browsing abilities
// * built-in less (to browse the buffers)
//
// This is a terminal emulator program, supporting terminal's resizing

#include <iterator>
#include <algorithm>

#include <vector>
#include <string>

#include <stdio.h>
#include <errno.h>
#include <string.h>

#include <signal>
#include <spawn.h>
#include <poll.h>
#include <pty.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

struct log_line_t
{
	uint64_t m_timestamp;
	char *m_start;
	char *m_end;
};

struct env_var_t
{
	char *m_name;
	char *m_val;
	char *m_end;
};

struct buffer_t
{
	vector<log_line_t> m_buffer_data;
	enum {STDIN,STDOUT,STDERR} m_buffer_type;
};

struct past_command_t
{
	uint64_t m_timestamp;
	string m_cmdline;
	buffer_t m_out, m_err;
	vector<env_var_t> m_env;
};

int main( int argc, char** argv )
{
	vector<past_command_t> history;
}
