% lmerge(1) lmerge manpage
% Bérenger Morel
% 2020-02-25

# NAME

*lmerge* - merges entries with common fields

# SYNOPSIS

`cat foo | *lmerge*`

# DESCRIPTION

Merges consecutive entries when they share a common field.
Entries are read from stdin.

*lmerge* does not remove duplicated fields.

# OPTIONS

Options can be managed either with traditional command-line parameters or via
environment variables.
List of environment variables that affect behavior:

FIELDS

: list of indexes (starting from 0, separated with **commas** (\',\', 0x2C) of
the fields that will be compared.

FIELD_SEP

: list of characters that will be considered as field separators.
Defaults to **space** (\' \', 0x20) and **horizontal tabulation** (\'\\t\', 0x09).

ENTRY_SEP

: list of characters that will be considered as entry separators.
Defaults to **newline** (\'\\n\', 0x0A).

For more details, use the '--help' commutator.

# EXAMPLE

This invocation:

```sh
FIELD_SEP=": \t" FIELDS="1,3" ./lmerge <<EOF
0 foo:hello:1
1 bar:hello:2
	2:foo:world:3
	2:bar:world:4
EOF
```

will generate this result:

```
0 foo:hello:1
1 bar:hello:2
	2:foo:world:3:	2:bar:world:4
```

If the feature was enabled, lmerge could have been summoned like this
`./lmerge -t': \t' -f1,3 ` instead of
`FIELD_SEP=": \t" FIELDS="1,3" ./lmerge`

# BUGS

Multi-byte characters can not be used for FIELD_SEP and ENTRY_SEP.

# SEE ALSO
