#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <assert.h>

#include <iterator>

#include <vector.hpp>
#include <optparser.hpp>

void print_help( char const* pgm, FILE* target, opt_desc_t const* start, opt_desc_t const* end );

int main( int argc, char** argv )
{
	opt_desc_t opts[] =
	{
		STD_HELP,
		{},
	};

	auto b_opts = std::begin( opts );
	auto e_opts = std::end( opts );
	char **arg = &argv[1];
	assert( argc > 0 );
	for( int iarg = 1; iarg != argc; ++iarg, ++arg )
	{
		auto error = parse_cmd_opt( *arg, b_opts, e_opts );
		switch( error )
		{
			case MAX_COUNT:
				arg_warning( *arg, error );
				break;
			case NONE:
			case IGNORED:
				break;
			case SET_NO_VAL:
			case SET_VAL_IGN:
			case SET_FAIL:
			case BAD_ARGS:
			case BAD_SETTER:
				print_help( argv[0], stderr, b_opts, e_opts );
				arg_error( *arg, error );
				return EXIT_FAILURE;
		}
	}
	if( opts[0].count )
	{
		print_help( argv[0], stdout, b_opts, e_opts );
		return EXIT_SUCCESS;
	}

	return EXIT_SUCCESS;
}

void print_help( char const* pgm, FILE* target, opt_desc_t const* start, opt_desc_t const* end )
{
 fputs( "Usage: ", target );
 fputs( pgm, target );
 fputs( " [OPTIONS]\n"
        "Description:\n"
        "Options:\n"
        , target );
 print_opts( target, start, end );
}
